# Ogre::DataStream Class Reference

General purpose class used for encapsulating the reading of data. More...

`#include <OgreDataStream.h>`

Inheritance diagram for Ogre::DataStream:

List of all members.

## Public Member Functions

| DataStream ()
| Constructor for creating unnamed streams.
| DataStream (const String &name)
| Constructor for creating named streams.
const String & | getName (void)
| Returns the name of the stream, if it has one.
virtual | ~DataStream ()
template<typename T> DataStream & | operator>> (T &val)
virtual size_t | read (void *buf, size_t count)=0
| Read the requisite number of bytes from the stream, stopping at the end of the file.
virtual size_t | readLine (char *buf, size_t maxCount, const String &delim="\n")=0
| Get a single line from the stream.
virtual String | getLine (bool trimAfter=true)
| Returns a String containing the next line of data, optionally trimmed for whitespace.
virtual String | getAsString (void)
| Returns a String containing the entire stream.
virtual size_t | skipLine (const String &delim="\n")=0
| Skip a single line from the stream.
virtual void | skip (long count)=0
| Skip a defined number of bytes.
virtual void | seek (size_t pos)=0
| Repositions the read point to a specified byte.
virtual size_t | tell (void) const=0
| Returns the current byte offset from beginning.
virtual bool | eof (void) const=0
| Returns true if the stream has reached the end.
size_t | size (void) const
| Returns the total size of the data to be read from the stream, or 0 if this is indeterminate for this stream.
virtual void | close (void)=0
| Close the stream; this makes further operations invalid.

## Protected Attributes

String | mName
| The name (e.g. resource name) that can be used to identify the source fot his data (optional).
size_t | mSize
| Size of the data in the stream (may be 0 if size cannot be determined).
char | mTmpArea [OGRE_STREAM_TEMP_SIZE]
| Temporary buffer area used for formatted read.

## Detailed Description

General purpose class used for encapsulating the reading of data.

Remarks:
  This class performs basically the same tasks as std::basic_istream, except that it does not have any formatting capabilities, and is designed to be subclassed to receive data from multiple sources, including libraries which have no compatiblity with the STL's stream interfaces. As such, this is an abstraction of a set of wrapper classes which pretend to be standard stream classes but can actually be implemented quite differently.

  Generally, if a plugin or application provides an ArchiveFactory, it should also provide a DataStream subclass which will be used to stream data out of that Archive implementation, unless it can use one of the common implementations included.

Note:
  Ogre makes no guarantees about thread safety, for performance reasons. If you wish to access stream data asynchronously then you should organise your own mutexes to avoid race conditions.

Definition at line 54 of file OgreDataStream.h.

## Constructor & Destructor Documentation

Ogre::DataStream::DataStream | ( |  | ) |

| Constructor for creating unnamed streams. Definition at line 66 of file OgreDataStream.h.

Ogre::DataStream::DataStream | ( | const String & | name | ) |

| Constructor for creating named streams. Definition at line 68 of file OgreDataStream.h. References Ogre::String.

virtual Ogre::DataStream::~DataStream | ( |  | ) | `[virtual]`

| Definition at line 71 of file OgreDataStream.h.

## Member Function Documentation

virtual void Ogre::DataStream::close | ( | void |  | ) | `[pure virtual]`

| Close the stream; this makes further operations invalid. Implemented in Ogre::MemoryDataStream, Ogre::FileStreamDataStream, Ogre::FileHandleDataStream, and Ogre::ZipDataStream.

virtual bool Ogre::DataStream::eof | ( | void |  | ) | const`[pure virtual]`

| Returns true if the stream has reached the end. Implemented in Ogre::MemoryDataStream, Ogre::FileStreamDataStream, Ogre::FileHandleDataStream, and Ogre::ZipDataStream.

virtual String Ogre::DataStream::getAsString | ( | void |  | ) | `[virtual]`

Returns a String containing the entire stream.

Remarks:
  This is a convenience method for text streams only, allowing you to retrieve a String object containing all the data in the stream.

virtual String Ogre::DataStream::getLine | ( | bool | trimAfter = true | ) | `[virtual]`

Returns a String containing the next line of data, optionally trimmed for whitespace.

Remarks:
  This is a convenience method for text streams only, allowing you to retrieve a String object containing the next line of data. The data is read up to the next newline character and the result trimmed if required.

Parameters:

  trimAfter | If true, the line is trimmed for whitespace (as in String.trim(true,true))

const String& Ogre::DataStream::getName | ( | void |  | ) |

| Returns the name of the stream, if it has one. Definition at line 70 of file OgreDataStream.h. References Ogre::String.

template<typename T>
DataStream& Ogre::DataStream::operator>> | ( | T & | val | ) |

virtual size_t Ogre::DataStream::read | ( | void * | buf,
|  | size_t | count
| ) | `[pure virtual]`

Read the requisite number of bytes from the stream, stopping at the end of the file.

Parameters:

  buf | Reference to a buffer pointer
  count | Number of bytes to read

Returns:
  The number of bytes read

Implemented in Ogre::MemoryDataStream, Ogre::FileStreamDataStream, Ogre::FileHandleDataStream, and Ogre::ZipDataStream.

virtual size_t Ogre::DataStream::readLine | ( | char * | buf,
|  | size_t | maxCount,
|  | const String & | delim = "\n"
| ) | `[pure virtual]`

Get a single line from the stream.

Remarks:
  The delimiter character is not included in the data returned, and it is skipped over so the next read will occur after it. The buffer contents will include a terminating character.

Parameters:

  buf | Reference to a buffer pointer
  maxCount | The maximum length of data to be read, excluding the terminating character
  delim | The delimiter to stop at

Returns:
  The number of bytes read, excluding the terminating character

Implemented in Ogre::MemoryDataStream, Ogre::FileStreamDataStream, Ogre::FileHandleDataStream, and Ogre::ZipDataStream.

virtual void Ogre::DataStream::seek | ( | size_t | pos | ) | `[pure virtual]`

| Repositions the read point to a specified byte. Implemented in Ogre::MemoryDataStream, Ogre::FileStreamDataStream, Ogre::FileHandleDataStream, and Ogre::ZipDataStream.

size_t Ogre::DataStream::size | ( | void |  | ) | const

| Returns the total size of the data to be read from the stream, or 0 if this is indeterminate for this stream. Definition at line 138 of file OgreDataStream.h.

virtual void Ogre::DataStream::skip | ( | long | count | ) | `[pure virtual]`

| Skip a defined number of bytes. This can also be a negative value, in which case the file pointer rewinds a defined number of bytes. Implemented in Ogre::MemoryDataStream, Ogre::FileStreamDataStream, Ogre::FileHandleDataStream, and Ogre::ZipDataStream.

virtual size_t Ogre::DataStream::skipLine | ( | const String & | delim = "\n" | ) | `[pure virtual]`

Skip a single line from the stream.

Parameters:

  delim | The delimiter(s) to stop at

Returns:
  The number of bytes skipped

Implemented in Ogre::MemoryDataStream, Ogre::FileStreamDataStream, Ogre::FileHandleDataStream, and Ogre::ZipDataStream.

virtual size_t Ogre::DataStream::tell | ( | void |  | ) | const`[pure virtual]`

| Returns the current byte offset from beginning. Implemented in Ogre::MemoryDataStream, Ogre::FileStreamDataStream, Ogre::FileHandleDataStream, and Ogre::ZipDataStream.

## Member Data Documentation

String Ogre::DataStream::mName `[protected]`

| The name (e.g. resource name) that can be used to identify the source fot his data (optional). Definition at line 58 of file OgreDataStream.h.

size_t Ogre::DataStream::mSize `[protected]`

| Size of the data in the stream (may be 0 if size cannot be determined). Definition at line 60 of file OgreDataStream.h.

char Ogre::DataStream::mTmpArea[OGRE_STREAM_TEMP_SIZE]`[protected]`

| Temporary buffer area used for formatted read. Definition at line 63 of file OgreDataStream.h.

The documentation for this class was generated from the following file:

- OgreDataStream.h

Copyright © 2000-2005 by The OGRE Team
Last modified Sun Nov 20 12:36:32 2005